// WriteReadDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WriteRead.h"
#include "WriteReadDlg.h"
#include "ET199_32.h"

#pragma comment(lib, "ET199_32S.lib")

DWORD g_dwRet=0;
DWORD g_dwCount=0;
ET_CONTEXT *g_pContext=NULL;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
void FlipBuffer(unsigned char* pBuf, unsigned long ulLen)
{
	unsigned char ucTemp;
	for(unsigned long i = 0; i < ulLen >> 1; ++i)
	{
		ucTemp = pBuf[i];
		pBuf[i] = pBuf[ulLen - i - 1];
		pBuf[ulLen - i - 1] = ucTemp;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteReadDlg dialog

CWriteReadDlg::CWriteReadDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWriteReadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWriteReadDlg)
	m_strData = _T("");
	m_iReadLen = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWriteReadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteReadDlg)
	DDX_Text(pDX, IDC_EDIT_DATA, m_strData);
	DDX_Text(pDX, IDC_EDIT_ReadLen, m_iReadLen);
	DDV_MinMaxUInt(pDX, m_iReadLen, 0, 256);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWriteReadDlg, CDialog)
	//{{AFX_MSG_MAP(CWriteReadDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_Write, OnBUTTONWrite)
	ON_BN_CLICKED(IDC_BUTTON_Read, OnBUTTONRead)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteReadDlg message handlers

BOOL CWriteReadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	
	// TODO: Add extra initialization here

	GetDlgItem(IDC_EDIT_DATA)->SetWindowText("磡HELLO");
	GetDlgItem(IDC_EDIT_ReadLen)->SetWindowText("8");


	//öET199
	g_dwRet=ETEnum(NULL,&g_dwCount);

	if(g_dwRet != ET_E_INSUFFICIENT_BUFFER && g_dwRet)
		return FALSE;

	//ڴڴ洢CONTEXTṹ
	g_pContext = new ET_CONTEXT[g_dwCount];

	//0
	memset(g_pContext,0,sizeof(ET_CONTEXT)*g_dwCount);

	//ʹ÷Ļ½ö
	g_dwRet=ETEnum(g_pContext,&g_dwCount);
	if(g_dwRet)
	{
		delete [] g_pContext;
		g_pContext = NULL;
		return FALSE;
	}

	//ET199
	g_dwRet = ETOpen(&g_pContext[0]);
	if(g_dwRet)
	{
		delete [] g_pContext;
		g_pContext = NULL;
		return FALSE;
	}

	//ִпִļǰִ֤ļĿ¼ûPIN
	g_dwRet = ETVerifyPin(&g_pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(g_dwRet)
	{
		delete [] g_pContext;
		g_pContext = NULL;
		return FALSE;
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWriteReadDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWriteReadDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWriteReadDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWriteReadDlg::OnBUTTONWrite() 
{
	// TODO: Add your control notification handler code here
	if(g_pContext == NULL)
	{
		AfxMessageBox("Not Open ET199");
		return;
	}

	UpdateData(TRUE);
	
	char cBuffer[256] = {0};
	char cOut[256] = {0};
	DWORD dwOutLen = 0;
	int iLen = m_strData.GetLength();
	DWORD wOffset = 10;	//ƫλΪ10ĵطʼд


	cBuffer[0] = 0;								//Ϊ0ʾдļ
	cBuffer[1] = (BYTE)iLen;					//дݳ
	FlipBuffer((unsigned char*)&wOffset, 2);	//C51WORDPC˳ͬȵ
	memcpy(cBuffer+2, &wOffset, 2);				//cBufferе±Ϊ23Ϊƫ
	memcpy(cBuffer+4, m_strData.GetBuffer(0), iLen); //Ҫд
	

	g_dwRet = ETExecute(&g_pContext[0],"0001", cBuffer, 4+iLen, cOut, 256, &dwOutLen);
	if(g_dwRet)
	{
		AfxMessageBox("ETExecute Error");
		return;
	}	

	//ز0ʱC51д
	if(cOut[0] != 0)
	{
		AfxMessageBox("Write Data Error");
		return;
	}

	AfxMessageBox("Write Data Success");	
}

void CWriteReadDlg::OnBUTTONRead() 
{
	// TODO: Add your control notification handler code here
	if(g_pContext == NULL)
	{
		AfxMessageBox("Not Open ET199");
		return;
	}

	char cBuffer[256] = {0};
	char cOut[256] = {0};
	DWORD dwOutLen = 0;
	WORD wOffset=10;	//ƫλΪ10ĵطʼȡ

	UpdateData(TRUE);
	
	

	cBuffer[0] = 1;								//Ϊ1ʾļ
	cBuffer[1] = (BYTE)m_iReadLen;				//ȡݳ
	FlipBuffer((unsigned char*)&wOffset, 2);	//C51WORDPC˳ͬȵ
	memcpy(cBuffer+2, &wOffset, 2);				//cBufferе±Ϊ23Ϊƫ
	
	g_dwRet = ETExecute(&g_pContext[0],"0001", cBuffer, 4, cOut, 256, &dwOutLen);
	if(g_dwRet)
	{
		AfxMessageBox("ETExecute Error");
		return;
	}	

	//سΪ1ʱC51г
	if(dwOutLen == 1)
	{
		AfxMessageBox("Read Data Error");
		return;
	}

	AfxMessageBox(cOut);	
	
}

void CWriteReadDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(g_pContext)
	{
		ETClose(&g_pContext[0]);
		delete [] g_pContext;
		g_pContext = NULL;
	}
	
	CDialog::OnClose();
}
